%% Generate synthetic data

ntrain=100;
ntest=300;



offset=1;

xtrain=.2*randn(2,ntrain);
xtest=.2*randn(2,ntest);

ntrain_cluster=floor(ntrain/4);
ntest_cluster=floor(ntest/4);

xtrain=xtrain+offset*[ones(2,ntrain_cluster) -ones(2,ntrain-3*ntrain_cluster) [ones(1,ntrain_cluster);-ones(1,ntrain_cluster)] [-ones(1,ntrain_cluster);ones(1,ntrain_cluster)]];
xtest=xtest+offset*[ones(2,ntest_cluster) -ones(2,ntest-3*ntest_cluster) [ones(1,ntest_cluster);-ones(1,ntest_cluster)] [-ones(1,ntest_cluster);ones(1,ntest_cluster)]];
ytrain=ones(1,ntrain);
ytrain(end-2*ntrain_cluster+1:end)=-1;
ytest=ones(1,ntest);
ytest(end-2*ntest_cluster+1:end)=-1;

%% Learn Local LDA classifier with 2 regions
[Fc Fr]=local_lda(xtrain,ytrain,2);



%% Display 2D classification region


if ~exist('xtest','var')
    xtest=xtrain;
end
d1min=min([xtrain(1,:) xtest(1,:) ])-1;
d1max=max([xtrain(1,:) xtest(1,:) ])+1;
d2min=min([xtrain(2,:) xtest(2,:) ])-1;
d2max=max([xtrain(2,:) xtest(2,:) ])+1;


[xmesh ymesh]=meshgrid(linspace(d1min,d1max,500),linspace(d2min,d2max,500));


[classifier_outputs regions]=eval_local_lda(Fc,Fr,[xmesh(:)';ymesh(:)']);

classifier_outputs=reshape(classifier_outputs,500,500);

regions=reshape(regions,500,500);

if ~exist('l','var')
    if exist('labels','var')
        l=labels;
    end
end

figure;
subplot(121);
imagesc(linspace(d1min,d1max,500),linspace(d2min,d2max,500),regions)
set(gca,'Xdir','normal');
set(gca,'Ydir','normal');
alpha(.5);
axis image;
hold on;
scatter(xtrain(1,:),xtrain(2,:),25,ytrain','.');
title('Partitioning Classifier Output');
subplot(122);
imagesc(linspace(d1min,d1max,500),linspace(d2min,d2max,500),classifier_outputs)
set(gca,'Xdir','normal');
set(gca,'Ydir','normal');
alpha(.5);
axis image;
hold on;
scatter(xtrain(1,:),xtrain(2,:),25,ytrain','.');
title('Predicted Labels');
